SystemOrganization addCategory: #'SmallAG-Tests'!
SystemOrganization addCategory: #'SmallAG-Model'!

Object subclass: #AGCommunicator
	instanceVariableNames: 'stream reader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallAG-Model'!

!AGCommunicator methodsFor: 'accessing' stamp: 'chaetal 10/19/2011 15:03'!
reader: aReader
	reader:= aReader! !

!AGCommunicator methodsFor: 'accessing' stamp: 'chaetal 10/19/2011 15:07'!
sendAndGetAnswer: aCommand
	| bytes |
	bytes := aCommand asByteArray .
	stream	 
		nextPutAll: bytes; 
		flushWriteBuffer.
	^ reader getAnswerOn: aCommand! !

!AGCommunicator methodsFor: 'accessing' stamp: 'chaetal 10/19/2011 15:02'!
stream: aStream
	stream := aStream! !

Object subclass: #AGDevice
	instanceVariableNames: 'path server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallAG-Model'!

!AGDevice class methodsFor: 'instance creation' stamp: 'chaetal 10/18/2011 09:30'!
newAt: aString on: aServer
	^ self new path: aString; server: aServer; yourself! !

!AGDevice methodsFor: 'accessing' stamp: 'chaetal 10/18/2011 09:30'!
path: aString
	path := aString! !

!AGDevice methodsFor: 'accessing' stamp: 'chaetal 10/18/2011 09:33'!
readVariableNamed: aString
	^ server readVariableNamed: aString from: path! !

!AGDevice methodsFor: 'accessing' stamp: 'chaetal 10/18/2011 09:32'!
server: aServer
	server := aServer! !

Object subclass: #AGServer
	instanceVariableNames: 'communicator protocol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallAG-Model'!

!AGServer class methodsFor: 'instance creation' stamp: 'chaetal 10/19/2011 14:32'!
protocol: aProtocol communicator: aCommunicator
	^ self new protocol: aProtocol; communicator: aCommunicator; yourself ! !

!AGServer methodsFor: 'accessing' stamp: 'chaetal 10/19/2011 14:43'!
communicator: aCommunicator
	communicator:= aCommunicator ! !

!AGServer methodsFor: 'accessing' stamp: 'chaetal 10/19/2011 14:43'!
protocol: aProtocol
	protocol := aProtocol ! !

!AGServer methodsFor: 'accessing' stamp: 'chaetal 10/19/2011 14:43'!
readVariableNamed: variableNameString from: pathString
	| command |
	command := protocol getVariableOperationCommandFor: variableNameString on: pathString.
	^ communicator sendAndGetAnswer: command ! !

TestCase subclass: #CommunicatorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallAG-Tests'!

!CommunicatorTests methodsFor: 'tests' stamp: 'chaetal 10/19/2011 15:07'!
testSendsCommandAndReturnsAnswer
	| communicator result |
	[ :clientStream :command :reader | 
	communicator := AGCommunicator new.
	communicator
		stream: clientStream;
		reader: reader.
	[ result := communicator sendAndGetAnswer: command ] should strictly
		satisfy: [ 
			command asByteArray willReturn: #bytes.
			clientStream nextPutAll: #bytes.
			clientStream flushWriteBuffer.
			(reader getAnswerOn: command) willReturn: #expectedAnswer ].
	result should be: #expectedAnswer ] runScenario! !

TestCase subclass: #DeviceTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallAG-Tests'!

!DeviceTests methodsFor: 'tests' stamp: 'chaetal 10/18/2011 09:33'!
testReadsVariableValueFromServer
	| device result |
	[ :server | 
	device := AGDevice newAt: #path on: server.
	[ result := device readVariableNamed: #variableName ] should strictly
		satisfy: [ (server readVariableNamed: #variableName from: #path) willReturn: #expectedValue ] ] runScenario.
	result should be: #expectedValue! !

TestCase subclass: #ServerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallAG-Tests'!

!ServerTests methodsFor: 'tests' stamp: 'chaetal 10/19/2011 14:43'!
testReadsVariable
	| result server |
	[ :protocol :communicator | 
	server := AGServer protocol: protocol communicator: communicator.
	[ result := server readVariableNamed: #variableName from: #path ] should strictly
		satisfy: [ 
			(protocol getVariableOperationCommandFor: #variableName on: #path) willReturn: #command.
			(communicator sendAndGetAnswer: #command) willReturn: #expectedResult ] ] runScenario.
	result should be: #expectedResult! !
